/*
Affichage val can ok sur page web
controle LED rouge ON ok
Pb de bouclage...

*/

/*
La procedure a suivre pour crer un serveur web avec envoi d'une donne :

Configuration de l'esp8266 : 
il faut que l'esp soit en mode AT+STA et connaitre l'adresse IP (IPscan32) ou utilisation du soft
ESPconfig.exe pour le placer dans le bon mode.

envoyer les commandes AT pour configurer le module ESP

A. Construire un Web server
1. Accepter les connections multiples : 
   envoyer "AT+CIPMUX=1\r\n"
2. Configurer en mode server  l'adresse 80  (80 car http sur port80)
   envoyer "AT+CIPSERVER=1,80\r\n"
3. Avec un navigateur web aller  l'adresse IP du module Wifi port80
   192.168.0.13:80 (chez moi)

4. Rception dune GET du module avec +IPD,0 ... avec 0 comme canal

5. Envoyer une rponse avec le canal et la taille des donnes en octet
   envoyer "AT+CIPSEND=channel,nboctet

Attention : finir l'envoi du html avec printf("\r\n\r\n"); le nb d'octet ne tient pas compte
de ce final.


6. Il faut fermer la connection 
*/

#include <16F876.h>

#device adc=8



#FUSES NOWDT                    //No Watch Dog Timer
#FUSES HS                       //High speed Osc (> 4mhz for PCM/PCH) (>10mhz for PCD)
#FUSES NOPUT                    //No Power Up Timer
#FUSES NOPROTECT                //Code not protected from reading
#FUSES NOBROWNOUT               //No brownout reset
#FUSES NOLVP                    //No low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O
#FUSES NOCPD                    //No EE protection
#FUSES NOWRT                    //Program memory not write protected
#FUSES NODEBUG                  //No Debug mode for ICD

#use delay(clock=20000000)
#use rs232(baud=9600,parity=N,xmit=PIN_C6,rcv=PIN_C7,bits=8,ERRORS)
#use rs232(baud=9600,parity=N,xmit=PIN_C5,rcv=PIN_C0,bits=8,stream=DEBUG,ERRORS)
#use i2c(Master,Fast,sda=PIN_C4,scl=PIN_C3)

#include <PCF2119_Driver_LCDI2C.c>
#include <stdlib.h>

#define allume_LEDVERTE output_high(PIN_C2);

#define  KEYHIT_DELAY   500     // in milliseconds
#define LEDROUGE PIN_C0 
#define LEDJAUNE PIN_C1
#define LEDVERTE PIN_C2

const int8 TailleBufferIn=30;

char DataBuffer[TailleBufferIn] ; //buffer d'entree
char HTML[30];
int8 valcan0;//valeur acquise sur canal0
int16 nboctet = 549;//attention nbctet doit etre exacte et inferieur  1024
boolean LEDROUGEON=true;//indicateur de LEDROUGE  ON ou off

#int_RDA
void  RDA_isr(void) 
{
int8 li;
int8 lchar;

//   disable_interrupts(GLOBAL); // all interrupts OFF
//   disable_interrupts(INT_RDA); // RS232 OF

 
//   enable_interrupts(GLOBAL); // all interrupts OFF
//   enable_interrupts(INT_RDA); // RS232 OFF

}

/*****************************************************************************/
boolean testOK(){

int8 i;
//attente OK
  while(getc()!='O') {};
  while(getc()!='K'){return(true);};
   
//fin attente OK

}//fin testOK
/*****************************************************************************/
/***************************************/
// initialisation du CAN
void initCAN(){
// initialise le CAN//
   setup_port_a( RA0_RA1_RA3_ANALOG );
   setup_adc( ADC_CLOCK_DIV_32 );
}

/***************************************/
// fonction d'acquisition : la valeur retourne est la valeur convertie du canal0
int8 acquerirCAN(int lcanal){

   int lvaquire;

   set_adc_channel( lcanal );
   delay_us(100);
   lvaquire=read_adc();
   return lvaquire;
}

void CreerFormHtml(){
//creation du formulaire HTML
//si LEDON alors 
//alors cocher la case de la LEDON et mettre la valeur  1
//sinon ne pas cocher la case de la LEDOFF et mettre la valeur  0
   printf("<form method=\"post\" name=\"form1\"><br>");//37char le \" permet d'crire " en html sans fermer le printf ! 

   if (LEDROUGEON)
   {
      printf("<input name=\"RDIOLR\" value=\"1\" ");//31char 
      printf("type=\"radio\" checked>LED ROUGE ON<br>");//37char
      printf("<input name=\"RDIOLR\" value=\"0\" ");//31char
      printf("type=\"radio\">LED ROUGE OFF<br>");//30char = 129total
   }//fin if LEDROUGEON
   else
   {
      printf("<input name=\"RDIOLR\" value=\"1\" ");//31char
      printf("type=\"radio\">LED ROUGE ON<br>");//29char
      printf("<input name=\"RDIOLR\" value=\"0\" ");//31char
      printf("type=\"radio\" checked>LED ROUGE OFF<br>");//38char = 129total
   }//fin else
   //ajout bouton submit 
   printf("<input type=\"submit\">");//21char
   printf("</form>");//7char
  
  
}//fin CreerFormHtml //37 + 129+21+7 = 194


void CreerStyleHtml(){
/*

creation du style de la page 
*/
      printf("<STYLE>");//7char
      printf("H1 {color:#804040;background:#FF8040;font-weight:bold;");//54char
      printf("font-family:Comic Sans MS;font-size:28;font-style:normal;");//57char
      printf("text-align:center;}");//19char
      printf("H2 {color:#000000;background:#FFFFFF;");//37char
      printf("font-family:Comic Sans MS;font-size:16;");//39char
      printf("font-style:normal;text-align:left;}");//35char
      printf("</STYLE>");//8char
//256 char
}//fin CreerStyleHtml
/*****************************************************************************/
void CreerPageHtml(){

      printf("<HTML><HEAD></HEAD>");//19 char
      CreerStyleHtml();//256char
      printf("<BODY bgcolor = '#FFFF7F'>");//26char
      printf("<H1>SERVEUR WEB</H1>");//20 char
      printf("<H2>CAN1 = %03u </H2>",valCAN0);//20char      
      CreerFormHtml();//194char
      printf("</BODY></HTML>");//14char
      printf("\r\n\r\n");

}//fin CreerPageHtml
/****************************************************************************/

/*****************************************************************************/
void main()
{
int8 i=0;
int8 channel=0;
char strbuffer[20];
int8 lchar;
int8 valCAN;

   setup_adc_ports(AN0_AN1_AN3);
   setup_adc(ADC_CLOCK_INTERNAL);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);

   // TODO: USER CODE!!

   set_tris_a(0b00111111);
   set_tris_b(0b11111111);
   set_tris_c(0b10010000);
   
   initCAN();
   
   
   Init_Ecran();
   Efface_Ecran();
   allume_LEDVERTE;
//   for (i=0;i<TailleBufferIn;i++) Data_buffer[i]='X';
//   enable_interrupts(INT_RDA);
//   enable_interrupts(GLOBAL);
    printf(Affiche_caractere,"Debut Wifi\n\r");   
    delay_ms(2000);
       //envoi command AT vers Wifi
   fputs("AT+RST"); //testOK();
   fprintf(DEBUG,"DEBUG ATRST\r\n");   delay_ms(1000);
//lecture de l'adresse IP du module ESP8266   
   fputs("AT+CIFSR");
   for(i=0;i<20;i++) 
   {
      DataBuffer[i]=getc(); //detecte si RDIOLR=1ou0
      if (DataBuffer[i] == 'K') break;
   }//for   
   Efface_Ecran();printf(Affiche_caractere,"%s ",DataBuffer);
   
   
   
    
do{  
 

//   fputs("ATE0");//annule l'echo des commandes AT
//   fprintf(DEBUG,"ATE0 \r\n");
//   delay_ms(1000);

   fputs("AT");//test la communication avec le module ESP8266
   testOK();//attent la confirmation OK du module

   delay_ms(1000);
   fputs("AT+CIPMUX=1");  testOK(); delay_ms(1000);  
   Efface_Ecran();printf(Affiche_caractere,"CIPMUX=OK"); delay_ms(1000);

   valCAN0 = acquerirCAN(0);

   fputs("AT+CIPSERVER=1,80");  testOK(); delay_ms(1000);
   Efface_Ecran();printf(Affiche_caractere,"Attente reqHTTP"); 
   Lcd_Place_Curseur(2, 1);  printf(Affiche_caractere,"CAN0 = %u",valCAN0);
   fprintf(DEBUG,"REQ HTTP? \r\n"); delay_ms(1000);
   
   while(getc()!='G') {};//attente du G de GET provenant d'une requete 
 
   Efface_Ecran();printf(Affiche_caractere,"Cfg canaldata"); delay_ms(1000);
   channel = 0; 
   printf("AT+CIPSEND=%u,%lu\r\n",channel,nboctet);//indique le canal et la taille des donnes envoyes

//   Efface_Ecran();printf(Affiche_caractere,"Attente >");//risque de gener la synchro
   while (getc()!='>'){};//attente > 
   CreerPageHtml();//envoi page web

   Efface_Ecran();printf(Affiche_caractere,"Envoi PageWeb"); delay_ms(10000);
   puts("AT+CIPCLOSE=0"); // delay_ms(1000); //fermeture de la connection 
  
  
     //printf(Affiche_caractere,"%s",buffer);
//attente d'une rponse de la page web par un POST
   //detecter la variable retour attendu "RDIOLR=1" (detecter RDI puis enregistrer dans un tableau afin de rcuperer le =0 ou =1
   Efface_Ecran();printf(Affiche_caractere,"Attente POST..");
   while(getc()!='R'){};
   while(getc()!='D'){};
   while(getc()!='I'){};
   while(getc()!='O'){};
   while(getc()!='L'){};
   while(getc()!='R'){};  
   while(getc()!='='){};
   if(getc()=='1') //ok test 
   {
      output_high(LEDROUGE);
      LEDROUGEON=true;
   }//if 
   else //sinon RDIOLR=0 alors eteindre ledrouge et memoriser l'info
   {
      output_low(LEDROUGE);
      LEDROUGEON=false;
      
   }//else
   /*
   for(i=0;i<5;i++) DataBuffer[i]=getc(); //detecte si RDIOLR=1ou0
   Efface_Ecran();printf(Affiche_caractere,"%s ",DataBuffer);
   if (DataBuffer[4] == "1") //si RDIOLR=1 alors allumer ledrouge et memoriser l'info
   {
      output_high(LEDROUGE);
      LEDROUGEON=true;
   }//if 
   else  if (DataBuffer[4] == "0") //sinon RDIOLR=0 alors eteindre ledrouge et memoriser l'info
   {
      output_low(LEDROUGE);
      LEDROUGEON=false;
      
   }//else
 */
   //printf(Affiche_caractere,"%s",buffer);
   //printf(Affiche_caractere,"Fin");
   
   
}while(1);
}//main
